%% TSP Program using Gemetic Algorithm

clc;
clear;
close all
%% Problem Statement

% This part is not available in beta version. You may use the original
% version of this code in matlabsite.com

% In bakhsh az code dar version beta vujud nadarad. Shoma mitavanid version
% original ra az "matlabsite.com" download konid.
matlabsite

%% Algorithm Parameters
PopSize = 300;
MaxGeneration = 1000;

Pc = .7;
Pm = .2;
Pr = 1 - Pc - Pm;

NumberofCrossOver = floor(Pc*PopSize);
NumberofMutation = floor(Pm*PopSize);
NumberofRecomb = PopSize - NumberofCrossOver - NumberofMutation;

%% Generating initial Population
Population = zeros(PopSize,NCity);

for ii = 1:PopSize 
    Population(ii,:) = randperm(NCity);
end
Population = SortPopulation(Population);
Cost = CityCostFunc(Population,CityDistance);

[Cost,indx] = sort(Cost);
Population = Population(indx,:);

MinimumCostM(1) = min(Cost); % For drawing purposes we keep trak of minimum and maximum costs of population.
MeanCostM(1) = mean(Cost);


%% %%%%%%%%%%%%%%%%%%%%% MAIN LOOP (Evolution) %%%%%%%%%%%%%%%%%%%%%%%%
for kkk = 1:MaxGeneration
        
    %% Selecting population
     RecombSelected = Population(1:NumberofRecomb,:);
     
     %% CrossOver
     NCost = max(Cost) - Cost;  % Normalized Cost
     Cost2 = NCost;

     pdfCost2 = Cost2/(sum(Cost2)); % Probability Density Function

     cdfCost2 = pdfCost2(1); % Cumulative Distribution Function
     for ii = 2:PopSize
         cdfCost2(ii) = cdfCost2(ii-1) + pdfCost2(ii);
     end
    % Now CDF is ready for Rollet Wheel selection
    
    % Selecting Parents
     a = rand(1,NumberofCrossOver);
     SelectedM = [];
     for ii = 1:numel(a);
         b = a(ii) - cdfCost2;
         c = b(b>0);
         Selected = numel(c)+1;
         SelectedM = [SelectedM ; Selected];
     end
     
     ParentsM = Population(SelectedM,:);

     % Generating Offsprings
     OFFSPRINGSM = [];
     for ii = 1:2:NumberofCrossOver
         
         p1 = ceil(NumberofCrossOver*rand);
         p2 = ceil(NumberofCrossOver*rand);
                  
         CrossPoint = ceil((NCity-1)*rand); %%%% Tavajjoh
         
         Parent1 = ParentsM(p1,:);
         Parent2 = ParentsM(p2,:);
         
         [OffSpring1 OffSpring2] = MyCrossOver(Parent1,Parent2,CrossPoint);
         OFFSPRINGSM = [OFFSPRINGSM ; OffSpring1 ; OffSpring2 ];
     end
     %%%% End of CrossOver %%%%
          
     %% Mutation
     f = randperm(PopSize);
     f2 = f(1:NumberofMutation);
     Mutated = Population(f2,:);
              
     for ii = 1:NumberofMutation
         R = randperm(NCity);
         n1 = R(1);
         n2 = R(2);
         Mutated2 = Mutated(ii,:);
         Mutated3 = Mutated2;
         
         Mutated3(n1) = Mutated2(n2);
         Mutated3(n2) = Mutated2(n1);
         
         Mutated(ii,:) = Mutated3;
     end
     %%%%% END of Mutation %%%%%
    
     Population = [RecombSelected ; OFFSPRINGSM ; Mutated];
     Population = SortPopulation(Population);
     Cost = CityCostFunc(Population,CityDistance);

     [Cost,indx] = sort(Cost);
     Population = Population(indx,:);
     [kkk min(Cost)]
%      subplot(2,1,1)
     MinimumCostM(kkk) = min(Cost); % For drawing purposes we keep trak of minimum and maximum costs of population.
     MeanCostM(kkk) = mean(Cost);
     plot(MinimumCostM,'r','linewidth',3)
     hold on
     plot(MeanCostM,'b','linewidth',2)
     hold off
     xlim([1 MaxGeneration]);
     pause(.05)
end

BestSolution = Population(1,:)
BestCost = Cost(1)